// misc.c  string conversions and other things, originally used for bme-280 sensor
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include "pico/stdlib.h"
#include "math.h"
#include "hardware/i2c.h"
#include "hardware/adc.h"
#include "hardware/spi.h"
#include "hardware/uart.h"
#include "misc.h"   // mine

#define LOG 0
#define DISPLAY_SECS 8
//==============================================
void itoa_hex(unsigned char bin)
{
   unsigned char1, char2, temp;

// Convert to ascii
   temp = bin & 0x0F;
   if(temp<10)
     {char2 = temp + 0x30;}
   else
     {char2 = temp + 0x37;}

   temp = bin>>4 & 0x0F;
   if(temp<10)
     {char1 = temp + 0x30;}
   else
     {char1 = temp + 0x37;}
    
// Add to string
   nstr[0] = char1;
   nstr[1] = char2;
   nstr[2] = 0;  // NULL
}
//=========================================
void itoa_hex_int(unsigned int bin)
{
   unsigned char cdigit[8], m, n;
   unsigned int temp;

//   bin = 0x1234;  // for testing
   m = 3;

// Convert to ascii
   for(n=0; n<4; n++)
   {
     temp = bin & 0x0F;
     if(temp<10)  {cdigit[n] = temp + 0x30;}
     else {cdigit[n] = temp + 0x37;}
     bin = bin>>4;
     nstr[m--] = cdigit[n];
   }

   nstr[n] = 0;   // NULL
}
//=========================================
void itoa_hex_long(unsigned long bin)
{
   unsigned char cdigit[8], m, n;
   unsigned long temp;

//   bin = 0x12345678;   // for testing
   m = 7;
// Convert to ascii
   for(n=0; n<8; n++)
   {
     temp = bin & 0x0F;
     if(temp<10)  {cdigit[n] = temp + 0x30;}
     else {cdigit[n] = temp + 0x37;}
     bin = bin>>4;
     nstr[m--] = cdigit[n];
   }

   nstr[n] = 0;   // NULL
}
//=========================================
void LED_break()
{
   while(1)  
   {
      gpio_put(LED1,1);
      sleep_ms(250); 
      gpio_put(LED1,0);
      sleep_ms(250); 
   }
}
//========================================
// show_time();  // only time in flash_entry
void show_time()
{
   struct log *ptr = &flash_entry;
   uint16_t m, n;

//   make_wx_entry(&flash_entry);  // make a log entry from time, Fdeg, p, Humidity 

   strcpy(line,"ZDA (UTC)   ");

// day name
   n = (ptr->ts_day)- 1;   // use it as an index
   for(m=0; m<3; m++)  { nstr[m] = day_array[n][m]; }
   nstr[m] = 0;
   strcat(line,nstr);
   strcat(line,"    ");   

   line_fill(ptr->ts_month, nstr, 0, 1);
   strcat(line,nstr);
   strcat(line,"/");

   line_fill(ptr->ts_date, nstr, 0, 1);
   strcat(line,nstr);
   strcat(line,"/");

   line_fill(ptr->ts_year, nstr, 0, 1);
   strcat(line,nstr);
   strcat(line,"    ");

   line_fill(ptr->ts_hours, nstr, 0, 1);
   strcat(line,nstr);
   strcat(line,":");

   line_fill(ptr->ts_minutes, nstr, 0, 1);
   strcat(line,nstr);
   strcat(line,":");

   line_fill(ptr->ts_seconds, nstr, 0, 1);
   strcat(line,nstr);
   strcat(line,"\n\n");

   uart_puts(UART_ID, line); 
}
//===============================================
// unsigned char to ASCII string, 3 digits
void uint8_bcd_str(unsigned char bin, char *str)    
{
// First Convert unsigned hex byte to BCD 
   int i;  
   unsigned char bcd0 = 0;
   unsigned char bcd1 = 0;
   unsigned char bcd2 = 0;
 
   unsigned char char1, char2, char3;
   unsigned char hcarry;

//bin = 0xA2;
   for(i=0; i<8; i++)
   {
//---------- BCD0
      bcd0 = bcd0<<1;

      if(bin & 0x80)
      {bcd0 = bcd0 +1;}

      bin = bin<<1;

      if(bcd0 >9)
      {
         bcd0 = bcd0 - 10;
         hcarry = 1;
      }
      else {hcarry = 0; }
//---------- BCD1
      bcd1 = bcd1<<1;
      bcd1 = bcd1 + hcarry;

      if(bcd1 >9)
      {
          bcd1 = bcd1 - 10;
          hcarry = 1;
      }
      else {hcarry = 0;}
//---------- BCD2
      bcd2 = bcd2<<1;
      bcd2 = bcd2 + hcarry;

      if(bcd2 >9)
      {
          bcd2 = bcd2 - 10;
//          hcarry = 1;
      }
//      else {hcarry = 0;}
   }

// Convert to ascii
   char1 = bcd2 + 0x30;
   char2 = bcd1 + 0x30;
   char3 = bcd0 + 0x30;

// Put it in the string
   str[0] = char1;
   str[1] = char2;
   str[2] = char3;
   str[3] = 0;      // NULL
}
//=================================================
// unsigned char to ASCII string, 2 digits
void uint8_bcd_str2(unsigned char bin, char *str)    
{
// First Convert unsigned hex byte to BCD 
   int i;  
   unsigned char bcd0 = 0;
   unsigned char bcd1 = 0;
 
   unsigned char char1, char2;
   unsigned char hcarry;

//bin = 0xA2;
   for(i=0; i<8; i++)
   {
//---------- BCD0
      bcd0 = bcd0<<1;

      if(bin & 0x80)
      {bcd0 = bcd0 +1;}

      bin = bin<<1;

      if(bcd0 >9)
      {
         bcd0 = bcd0 - 10;
         hcarry = 1;
      }
      else {hcarry = 0; }
//---------- BCD1
      bcd1 = bcd1<<1;
      bcd1 = bcd1 + hcarry;

      if(bcd1 >9)
      {
          bcd1 = bcd1 - 10;
          hcarry = 1;
      }
//      else {hcarry = 0;}
   }

// Convert to ascii
   char1 = bcd1 + 0x30;
   char2 = bcd0 + 0x30;

// Put it in the string
   str[0] = char1;
   str[1] = char2;
   str[2] = 0;      // NULL
}
//=================================================
// signed char to ASCII string, 3 digits
void sint8_bcd_str(int8_t bin, char *str)    
{
   int i;  
   unsigned char bcd0 = 0;
   unsigned char bcd1 = 0;
   unsigned char bcd2 = 0;
 
   unsigned char char1, char2, char3, sflag;
   unsigned char hcarry;

   if(bin <0)
   {
      bin = -bin;
      sflag = 1;
   }
   else {sflag = 0;}

// Convert unsigned hex byte to BCD 
   for(i=0; i<8; i++)
   {
//---------- BCD0
      bcd0 = bcd0<<1;

      if(bin & 0x80)
      {bcd0 = bcd0 +1;}

      bin = bin<<1;

      if(bcd0 >9)
      {
         bcd0 = bcd0 - 10;
         hcarry = 1;
      }
      else {hcarry = 0; }
//---------- BCD1
      bcd1 = bcd1<<1;
      bcd1 = bcd1 + hcarry;

      if(bcd1 >9)
      {
          bcd1 = bcd1 - 10;
          hcarry = 1;
      }
      else {hcarry = 0;}
//---------- BCD2
      bcd2 = bcd2<<1;
      bcd2 = bcd2 + hcarry;

      if(bcd2 >9)
      {
          bcd2 = bcd2 - 10;
//          hcarry = 1;
      }
//      else {hcarry = 0;}

   }

// Convert to ascii
   char1 = bcd2 + 0x30;
   char2 = bcd1 + 0x30;
   char3 = bcd0 + 0x30;

// Put it in the string
   if(sflag)
   {
      str[0] = '-';
      str[1] = char1;
      str[2] = char2;
      str[3] = char3;
      str[4] = 0;      // NULL

   }
   else
   {
      str[0] = char1;
      str[1] = char2;
      str[2] = char3;
      str[3] = 0;      // NULL
   }
}
//=================================================
// uint16 to ASCII string, 5 digits
void uint16_bcd_str(uint16_t bin, char *str)
{
   unsigned char bcd0 = 0;
   unsigned char bcd1 = 0;
   unsigned char bcd2 = 0;
   unsigned char bcd3 = 0;
   unsigned char bcd4 = 0;
   unsigned char char1, char2, char3, char4, char5;
   int i;
   unsigned char hcarry;

// Convert Binary to BCD
   for(i=0; i<16; i++)
   {
//---------- BCD0
      bcd0 = bcd0<<1;

      if(bin & 0x8000)
      {bcd0 = bcd0 +1;}

      bin = bin<<1;

      if(bcd0 >9)
      {
         bcd0 = bcd0 - 10;
         hcarry = 1;
      }
      else {hcarry = 0; }
//---------- BCD1
      bcd1 = bcd1<<1;
      bcd1 = bcd1 + hcarry;

      if(bcd1 >9)
      {
          bcd1 = bcd1 - 10;
          hcarry = 1;
      }
      else {hcarry = 0;}
//---------- BCD2
      bcd2 = bcd2<<1;
      bcd2 = bcd2 + hcarry;

     if(bcd2 >9)
     {
         bcd2 = bcd2 - 10;
         hcarry = 1;
     }
         else {hcarry = 0;}
//---------- BCD3
     bcd3 = bcd3<<1;
     bcd3 = bcd3 + hcarry;

     if(bcd3 >9)
     {
         bcd3 = bcd3 - 10;
       hcarry = 1;
     }
         else {hcarry = 0;}
//---------- BCD4
     bcd4 = bcd4<<1;
     bcd4 = bcd4 + hcarry;

     if(bcd4 >9)
     {
         bcd4 = bcd4 - 10;
//       hcarry = 1;
     }
//         else {hcarry = 0;}

   }

// Convert to ascii
   char1 = bcd4 + 0x30;
   char2 = bcd3 + 0x30;
   char3 = bcd2 + 0x30;
   char4 = bcd1 + 0x30;
   char5 = bcd0 + 0x30;

// Make the string
   str[0] = char1;
   str[1] = char2;
   str[2] = char3;
   str[3] = char4;
   str[4] = char5;
   str[5] = 0;  // NULL
}
//=================================================
// uint16 to ASCII string to uart - 4 digits
void uint16_bcd_str4(uint16_t bin, char *str)   //unsigned int to BCD string
{
   unsigned char bcd0 = 0;
   unsigned char bcd1 = 0;
   unsigned char bcd2 = 0;
   unsigned char bcd3 = 0;
   unsigned char char1, char2, char3, char4;
   int i;
   unsigned char hcarry;

// Convert Binary to BCD
   for(i=0; i<16; i++)
   {
//---------- BCD0
      bcd0 = bcd0<<1;

      if(bin & 0x8000)
      {bcd0 = bcd0 +1;}

      bin = bin<<1;

      if(bcd0 >9)
      {
         bcd0 = bcd0 - 10;
         hcarry = 1;
      }
      else {hcarry = 0; }

//---------- BCD1
      bcd1 = bcd1<<1;
      bcd1 = bcd1 + hcarry;

      if(bcd1 >9)
      {
          bcd1 = bcd1 - 10;
          hcarry = 1;
      }
      else {hcarry = 0;}

//---------- BCD2
      bcd2 = bcd2<<1;
      bcd2 = bcd2 + hcarry;

     if(bcd2 >9)
     {
         bcd2 = bcd2 - 10;
         hcarry = 1;
     }
         else {hcarry = 0;}

//---------- BCD3
     bcd3 = bcd3<<1;
     bcd3 = bcd3 + hcarry;

     if(bcd3 >9)
     {
         bcd3 = bcd3 - 10;
       hcarry = 1;
     }
//         else {hcarry = 0;}
   }

// Convert to ascii
   char1 = bcd3 + 0x30;
   char2 = bcd2 + 0x30;
   char3 = bcd1 + 0x30;
   char4 = bcd0 + 0x30;

// Make the string
   str[0] = char1;
   str[1] = char2;
   str[2] = char3;
   str[3] = char4;
   str[4] = 0;  // NULL
}
//=================================================
// sint16 to ASCII string, 5 digits
void sint16_bcd_str(int16_t bin, char *str)
{
   unsigned char bcd0 = 0;
   unsigned char bcd1 = 0;
   unsigned char bcd2 = 0;
   unsigned char bcd3 = 0;
   unsigned char bcd4 = 0;
   unsigned char char1, char2, char3, char4, char5, sflag;
   int i;
   unsigned char hcarry;

   if(bin <0)
   {
      bin = -bin;
      sflag = 1; 
   }
   else {sflag = 0; }

// Convert Binary to BCD
   for(i=0; i<16; i++)
   {
//---------- BCD0
      bcd0 = bcd0<<1;

      if(bin & 0x8000)
      {bcd0 = bcd0 +1;}

      bin = bin<<1;

      if(bcd0 >9)
      {
         bcd0 = bcd0 - 10;
         hcarry = 1;
      }
      else {hcarry = 0; }
//---------- BCD1
      bcd1 = bcd1<<1;
      bcd1 = bcd1 + hcarry;

      if(bcd1 >9)
      {
          bcd1 = bcd1 - 10;
          hcarry = 1;
      }
      else {hcarry = 0;}
//---------- BCD2
      bcd2 = bcd2<<1;
      bcd2 = bcd2 + hcarry;

     if(bcd2 >9)
     {
         bcd2 = bcd2 - 10;
         hcarry = 1;
     }
         else {hcarry = 0;}
//---------- BCD3
     bcd3 = bcd3<<1;
     bcd3 = bcd3 + hcarry;

     if(bcd3 >9)
     {
         bcd3 = bcd3 - 10;
       hcarry = 1;
     }
         else {hcarry = 0;}
//---------- BCD4
     bcd4 = bcd4<<1;
     bcd4 = bcd4 + hcarry;

     if(bcd4 >9)
     {
         bcd4 = bcd4 - 10;
//       hcarry = 1;
     }
//         else {hcarry = 0;}
   }

// Convert to ascii
   char1 = bcd4 + 0x30;
   char2 = bcd3 + 0x30;
   char3 = bcd2 + 0x30;
   char4 = bcd1 + 0x30;
   char5 = bcd0 + 0x30;

// Make the string
   if(sflag)
   {
      str[0] = '-';
      str[1] = char1;
      str[2] = char2;
      str[3] = char3;
      str[4] = char4;
      str[5] = char5;
      str[6] = 0;      // NULL
   }
   else
   {
      str[0] = char1;
      str[1] = char2;
      str[2] = char3;
      str[3] = char4;
      str[4] = char5;
      str[5] = 0;      // NULL
   }
}
//===============================================
// uint32 to ASCII string, 10 digits 
void uint32_bcd_str(uint32_t bin, char *str)
{
   unsigned char bcd0 = 0;
   unsigned char bcd1 = 0;
   unsigned char bcd2 = 0;
   unsigned char bcd3 = 0;
   unsigned char bcd4 = 0;
   unsigned char bcd5 = 0;
   unsigned char bcd6 = 0;
   unsigned char bcd7 = 0;
   unsigned char bcd8 = 0;
   unsigned char bcd9 = 0;
   unsigned char char1, char2, char3, char4, char5, char6, char7, char8, char9, char10;
   int i;
   unsigned char hcarry;

// Convert Binary to BCD
   for(i=0; i<32; i++)
   {
//---------- BCD0
      bcd0 = bcd0<<1;

      if(bin & 0x80000000)
      {bcd0 = bcd0 +1;}

      bin = bin<<1;

      if(bcd0 >9)
      {
         bcd0 = bcd0 - 10;
         hcarry = 1;
      }
      else {hcarry = 0; }
//---------- BCD1
      bcd1 = bcd1<<1;
      bcd1 = bcd1 + hcarry;

      if(bcd1 >9)
      {
          bcd1 = bcd1 - 10;
          hcarry = 1;
      }
      else {hcarry = 0;}
//---------- BCD2
      bcd2 = bcd2<<1;
      bcd2 = bcd2 + hcarry;

     if(bcd2 >9)
     {
         bcd2 = bcd2 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD3
     bcd3 = bcd3<<1;
     bcd3 = bcd3 + hcarry;

     if(bcd3 >9)
     {
         bcd3 = bcd3 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD4
     bcd4 = bcd4<<1;
     bcd4 = bcd4 + hcarry;

     if(bcd4 >9)
     {
         bcd4 = bcd4 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD5
     bcd5 = bcd5<<1;
     bcd5 = bcd5 + hcarry;

     if(bcd5 >9)
     {
         bcd5 = bcd5 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD6
     bcd6 = bcd6<<1;
     bcd6 = bcd6 + hcarry;

     if(bcd6 >9)
     {
         bcd6 = bcd6 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD7
     bcd7 = bcd7<<1;
     bcd7 = bcd7 + hcarry;

     if(bcd7 >9)
     {
         bcd7 = bcd7 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD8
     bcd8 = bcd8<<1;
     bcd8 = bcd8 + hcarry;

     if(bcd8 >9)
     {
         bcd8 = bcd8 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD9
     bcd9 = bcd9<<1;
     bcd9 = bcd9 + hcarry;

     if(bcd9 >9)
     {
         bcd9 = bcd9 - 10;
//         hcarry = 1;
     }
//   else {hcarry = 0;}
   }  // end for

// Convert to ascii
   char1 = bcd9 + 0x30;
   char2 = bcd8 + 0x30;
   char3 = bcd7 + 0x30;
   char4 = bcd6 + 0x30;
   char5 = bcd5 + 0x30;
   char6 = bcd4 + 0x30;
   char7 = bcd3 + 0x30;
   char8 = bcd2 + 0x30;
   char9 = bcd1 + 0x30;
   char10 = bcd0 + 0x30;

// Make the string
   str[0] = char1;
   str[1] = char2;
   str[2] = char3;
   str[3] = char4;
   str[4] = char5;
   str[5] = char6;
   str[6] = char7;
   str[7] = char8;
   str[8] = char9;
   str[9] = char10;
   str[10] = 0;  // NULL
}
//===============================================
// sint32 to ASCII string, 10 digits
void sint32_bcd_str(int32_t bin, char *str)    // int32_t to BCD string
{
   unsigned char bcd0 = 0;
   unsigned char bcd1 = 0;
   unsigned char bcd2 = 0;
   unsigned char bcd3 = 0;
   unsigned char bcd4 = 0;
   unsigned char bcd5 = 0;
   unsigned char bcd6 = 0;
   unsigned char bcd7 = 0;
   unsigned char bcd8 = 0;
   unsigned char bcd9 = 0;
   unsigned char char1, char2, char3, char4, char5, char6, char7, char8, char9, char10, sflag;
   int i;
   unsigned char hcarry;

   if(bin <0)
   {
      bin = -bin;
      sflag = 1;
   }
   else { sflag = 0; }

// Convert Binary to BCD
   for(i=0; i<32; i++)
   {
//---------- BCD0
      bcd0 = bcd0<<1;

      if(bin & 0x80000000)
      {bcd0 = bcd0 +1;}

      bin = bin<<1;

      if(bcd0 >9)
      {
         bcd0 = bcd0 - 10;
         hcarry = 1;
      }
      else {hcarry = 0; }
//---------- BCD1
      bcd1 = bcd1<<1;
      bcd1 = bcd1 + hcarry;

      if(bcd1 >9)
      {
          bcd1 = bcd1 - 10;
          hcarry = 1;
      }
      else {hcarry = 0;}
//---------- BCD2
      bcd2 = bcd2<<1;
      bcd2 = bcd2 + hcarry;

     if(bcd2 >9)
     {
         bcd2 = bcd2 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD3
     bcd3 = bcd3<<1;
     bcd3 = bcd3 + hcarry;

     if(bcd3 >9)
     {
         bcd3 = bcd3 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD4
     bcd4 = bcd4<<1;
     bcd4 = bcd4 + hcarry;

     if(bcd4 >9)
     {
         bcd4 = bcd4 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD5
     bcd5 = bcd5<<1;
     bcd5 = bcd5 + hcarry;

     if(bcd5 >9)
     {
         bcd5 = bcd5 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD6
     bcd6 = bcd6<<1;
     bcd6 = bcd6 + hcarry;

     if(bcd6 >9)
     {
         bcd6 = bcd6 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD7
     bcd7 = bcd7<<1;
     bcd7 = bcd7 + hcarry;

     if(bcd7 >9)
     {
         bcd7 = bcd7 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD8
     bcd8 = bcd8<<1;
     bcd8 = bcd8 + hcarry;

     if(bcd8 >9)
     {
         bcd8 = bcd8 - 10;
         hcarry = 1;
     }
     else {hcarry = 0;}
//---------- BCD9
     bcd9 = bcd9<<1;
     bcd9 = bcd9 + hcarry;

     if(bcd9 >9)
     {
         bcd9 = bcd9 - 10;
//         hcarry = 1;
     }
//   else {hcarry = 0;}
   }  // end for

// Convert to ascii
   char1 = bcd9 + 0x30;
   char2 = bcd8 + 0x30;
   char3 = bcd7 + 0x30;
   char4 = bcd6 + 0x30;
   char5 = bcd5 + 0x30;
   char6 = bcd4 + 0x30;
   char7 = bcd3 + 0x30;
   char8 = bcd2 + 0x30;
   char9 = bcd1 + 0x30;
   char10 = bcd0 + 0x30;

// Make the string
   if(sflag)
   {
      str[0] = '-';
      str[1] = char1;
      str[2] = char2;
      str[3] = char3;
      str[4] = char4;
      str[5] = char5;
      str[6] = char6;
      str[7] = char7;
      str[8] = char8;
      str[9] = char9;
      str[10] = char10;
      str[11] = 0;  // NULL
   }
   else
   {
      str[0] = char1;
      str[1] = char2;
      str[2] = char3;
      str[3] = char4;
      str[4] = char5;
      str[5] = char6;
      str[6] = char7;
      str[7] = char8;
      str[8] = char9;
      str[9] = char10;
      str[10] = 0;  // NULL
   }
}
//===============================================
// unsigned 8 bits to ASCII string as 2 hex digits
void uint8_hex_str(uint8_t bin, char *str)   //unsigned char to hex string    
{
   unsigned char1, char2, temp;

// Convert to ascii
   temp = bin & 0x0F;
   if(temp<10)
     {char2 = temp + 0x30;}
   else
     {char2 = temp + 0x37;}

   temp = bin>>4 & 0x0F;
   if(temp<10)
     {char1 = temp + 0x30;}
   else
     {char1 = temp + 0x37;}
    
// Make string
   str[0] = char1;
   str[1] = char2;
   str[2] = 0;
}
//==========================================================
// uint16 to ASCII string as 4 hex digits
void uint16_hex_str(uint16_t bin, char *str)
{
   unsigned char1, char2, char3, char4, temp;

// Convert to ascii
   temp = bin & 0x0F;
   if(temp<10)
     {char4 = temp + 0x30;}
   else
     {char4 = temp + 0x37;}

   temp = bin>>4 & 0x0F;
   if(temp<10)
     {char3 = temp + 0x30;}
   else
     {char3 = temp + 0x37;}

   temp = bin>>8 & 0x0F;
   if(temp<10)
     {char2 = temp + 0x30;}
   else
     {char2 = temp + 0x37;}

   temp = bin>>12 & 0x0F;
   if(temp<10)
     {char1 = temp + 0x30;}
   else
     {char1 = temp + 0x37;}

   str[0] = char1;
   str[1] = char2;
   str[2] = char3;
   str[3] = char4;
   str[4] = 0;  // NULL
}
//============================================
// uint32 to ASCII string as 8 hex digits
void uint32_hex_str(unsigned long bin, char *str)  // uint32 to ASCII string as 8 hex digits
// long int hex to string, space between ints
{
// Convert Binary to BCD
   unsigned int m, n;
   char temp[10];

   m = 7;
   for(n=0; n<8; n++)
   {
      temp[m] = bin & 0x0F;
      m--;
      bin = bin>>4;
   }
   asm(" nop");    // for emulator

   // Convert to ascii
   for(n=0; n<8; n++)
   {
     if(temp[n]<10)  { temp[n] = temp[n] + 0x30; }
     else            { temp[n] = temp[n] + 0x37; }
   }
  
// Format the string
   for(n=0; n<4; n++)  { str[n] = temp[n]; }
   str[4] = ' ';

   for(n=4; n<8; n++)  { str[n+1] = temp[n]; }
   str[9] = 0x00;  // NULL   Now it is a string

   asm(" nop");    // for emulator
}
//========================================
#if NO
void test_week_day()
{
   uint8_t weekday;
   
   weekday = do_day_of_week(9,28,24);   //sat
   test_sint16(30, weekday);

   weekday = do_day_of_week(9,29,24);  // sun
   test_sint16(30, weekday);

   weekday = do_day_of_week(9,30,24);  // mon
   test_sint16(30, weekday);

   weekday = do_day_of_week(10,1,24);  // tue
   test_sint16(30, weekday);

   weekday = do_day_of_week(10,2,24);   //wed
   test_sint16(30, weekday);
 
   weekday = do_day_of_week(10,3,24);   // thu
   test_sint16(30, weekday);

   weekday = do_day_of_week(10,4,24);  // fri
   test_sint16(30, weekday);

   weekday = do_day_of_week(10,5,24);  // sat
   test_sint16(30, weekday);

   weekday = do_day_of_week(10,6,24);  // sun
   test_sint16(30, weekday);
}
#endif
//==========================================================
