// misc.h for misc.c
#include "common.h"
//----------------------------------------------------------------
const uint16_t structlogsize = 16;   // size of log struct (for logging in Flash)

uint16_t wait_ready(void);
void line_fill(unsigned char, char *, unsigned char, unsigned char);

char nstr[512];   // new string segment
char line[512];   // string for uart

void itoa_hex(unsigned char);
void itoa_hex_int(unsigned int);
void lcd_byte(unsigned char);    // clear screen

extern void lcd_wr_hex(unsigned int, unsigned char);
extern void lcd_wr_data(unsigned char);
extern void do_led_break(void);
extern void SetCmdMode(void);
extern void lcd_wr_instr(unsigned char);

unsigned char test_buffer[32];
signed long testvars[32];
void lcd_display(void);
//=========================================
extern const char version[];

void my_itoa(unsigned int,char *);
void LED_break(void);

extern unsigned char uart_char;
extern uint16_t secs_flag;

extern struct log flash_entry;    

extern uint16_t Page_Index, Last_Page, Sector_Index;

extern void do_start_date(uint16_t);
extern char start_date[];
extern uint16_t ts_number;
extern unsigned int Entry_Read_Index, Flash_Write_Index, erase_flag, reset_rx_start;
void do_uart_RX(void);
extern void make_entry(void);
extern void test_read_sector(uint16_t);
extern void myflash_erase_sector(uint16_t);
extern void erase_sector(uint16_t);
extern void erase_all_sectors(void);
extern void dump_flash(uint32_t, uint32_t);
extern void write_page(uint32_t, unsigned char *);
extern void show_log(struct log *);
void show_entry(struct log *);
void show_time(void);
extern const char day_array[7][3];
void my_hextoa2(unsigned char, char *);
//==================
void uint8_bcd_str(unsigned char, char *);   // unsigned char to ASCII string, 3 digits  
void uint8_bcd_str2(unsigned char, char *);  // unsigned char to ASCII string, 2 digits
extern void do_clock8(uint8_t);              // does it with a lookup table, fast
void sint8_bcd_str(int8_t, char *);          // signed char to ASCII string, 3 digits    
void uint16_bcd_str(uint16_t, char *);       // uint16 to ASCII string, 5 digits
void uint16_bcd_str4(uint16_t, char *);      // uint16 to ASCII string, 4 digits
void sint16_bcd_str(int16_t, char *);        // int16 to ASCII string, 5 digits
void uint32_bcd_str(uint32_t, char *);       // uint32_t to ASCII string, 8 digits
void sint32_bcd_str(int32_t, char *);        // int32_t to ASCII string, 8 digits
void uint8_hex_str(uint8_t, char *);         // unsigned char to ASCII string as hex digits, 2 digits    
void uint16_hex_str(uint16_t, char *);       // uint16 to ASCII string as 4 hex digits
void uint32_hex_str(unsigned long, char *);  // uint32 to ASCII string as 8 hex digits

extern void get_gps_msg_GNZDA(char);
extern void get_gps_msg_GSV(char);

extern unsigned char nflag;
extern void domsg(const struct messages *);
extern void set_reference(void);
//======================================
extern struct alltime time;

void get_local(void);
void start_local(void);
void test_local(void);
extern void test_sint16(int16_t, int16_t);
uint16_t do_day_of_week(uint8_t, uint8_t, uint8_t);  // returns with string in nstr
//====================================
